package UpperMatch;
use strict;
use warnings;
use DBI;
use URI::Escape;

########################NOLA ERABILI###################################
#          use_matchSQL.pl-n daude erabilera guztiak                  #     
#######################################################################

my $dbh;
my $dict_path = "";
my $conf_file = "";
my $UPPER = 1;

my $host;
my $user;
my $pwd;
my $dbname;
my $lang;
my %stopwords ;

init_stopwords() ;

sub setUPPER
{
    $UPPER = $_[0];
}

sub init_PostGres
{
    $conf_file = $_[0];
    open (Fitx,"$conf_file") or die $!;
    binmode Fitx, ":utf8";    
    while (defined (my $line = <Fitx>))
    {
	chomp $line;
	if ($line =~ m/host=(.*)/)
	{
	    $host=$1;
	}
	if ($line =~ m/user=(.*)/)
	{
	    $user=$1;
	}
	if ($line =~ m/pwd=(.*)/)
	{
	    $pwd=$1;
	}
	if ($line =~ m/dbname=(.*)/)
	{
	    $dbname=$1;
	}
	if ($line =~ m/lang=(.*)/)
	{
	    $lang=$1;
	}
    }
}

sub connect_Database
{
    init_PostGres ($_[0]);
    $dbh = DBI->connect("DBI:Pg:dbname=$dbname;host=$host", "$user", "$pwd");
    if (!$dbh)
    {
	die "$dbname doesn't exist";
    }
}

sub disconnect_Database
{
    $dbh->disconnect;
}

sub create_Database
{
    $dict_path = $_[0];
    init_PostGres ($_[1]);
    my %first_word = ();
    $dbh = DBI->connect("DBI:Pg:dbname=$dbname;host=$host", "$user", "$pwd");
    if (!$dbh)
    {
	die "Create UTF-8 database with $dbname name.\n";	
    }
    if ($dbh)
    {    
	print "$dbname: do you want to (re)write all? this will take 2-3 hours. yes/no\n";
	my $yesno =  <STDIN>;
	chomp ($yesno);
	if ($yesno eq "yes")
	{
	    my $sortze_data = gmtime(time());
	    my $sth = $dbh->prepare("DROP TABLE metadata, dictionary, firstword;");
	    $sth->execute();
	    $sth = $dbh->prepare("CREATE TABLE metadata (dbname text PRIMARY KEY, date text, dict_path text, lang text);");#text jarri
	    $sth->execute();
	    $dbh->do("INSERT INTO metadata (dbname,date,dict_path,lang) VALUES (E'$dbname',E'$sortze_data',E'$dict_path',E'$lang')") or die ("Cannot INSERT");
	    $sth = $dbh->prepare("CREATE TABLE dictionary (entry text PRIMARY KEY, entities text);");#text jarri
	    $sth->execute();
	    $sth = $dbh->prepare("CREATE TABLE firstword (firstword text PRIMARY KEY, maximunlength integer);");
	    $sth->execute();
	    open (I,"-|:encoding(UTF-8)", "bzcat $dict_path") || die $! ; 
	    my ($anch,@ent);
	    while (<I>) 
	    {
		chomp;
		($anch,@ent) = split(/\s/,$_) ;
		$anch =~ s/\'/''/g;
		if ($anch =~ m/^([^_]*)_/)
		{
		    if (defined $first_word {$1})
		    {
			my $aurrekoluzera = $first_word {$1};
			if ($aurrekoluzera < length($anch))
			{
			    $first_word {$1} = length($anch);
			}
		    }
		    else
		    {
			$first_word {$1} = length($anch);
		    }
		}
		if ($anch =~ m/^([^_]*)$/)
		{
		    if (defined $first_word {$1})
		    {
			my $aurrekoluzera = $first_word {$1};
			if ($aurrekoluzera < length($anch))
			{
			    $first_word {$1} = length($anch);
			}
		    }
		    else
		    {
			$first_word {$1} = length($anch);
		    }
		}
		foreach my $a (@ent)
		{
		    $a =~ s/\'/''/g;
		}		
		$dbh->do("INSERT INTO dictionary(entry,entities) VALUES (E'".uri_escape_utf8($anch)."',E'".uri_escape_utf8("@ent")."');");
	    }
	    foreach my $firstword (keys %first_word)
	    {
		$dbh->do("INSERT INTO firstword (firstword,maximunlength) VALUES (E'".uri_escape_utf8($firstword)."',E'".uri_escape_utf8($first_word{$firstword})."');");
	    }
	    $sth->finish(); 
	    warn "$dbname created ...\n";
	}
    }
}

sub get_most_likely_BGlink
{
    my $entry = &to_anchor($_[0]);
    my $result ;
    $entry =~ s/\'/''/g;
    my @ent;
    my $winner;
    my $frekMax = 0;
    if ($dbh)
    {
	my $sth = $dbh->prepare("SELECT * FROM dictionary WHERE entry = '".uri_escape_utf8($entry)."'");
	$sth->execute();
	while(my $tupla = $sth->fetchrow_hashref()) 
	{    
	    @ent = split(" ",uri_unescape($tupla->{'entities'}));
	    foreach my $ent_frek (@ent)
	    {
		my($enti,$frek)= &parse_ent_freq($ent_frek);
		if ($frekMax < $frek)
		{
		    $winner = $enti;
		    $frekMax = $frek;
		}		
	    }
	    $result = $winner;
	}
    }
    else
    {
	die "database not working\n";		
    }
    return $result;
}

sub get_BGlinks
{  
    my $entry = &to_anchor($_[0]);
    my $top_k = $_[1];
    $top_k = 0 if !defined($top_k);
    my @result ;
    $entry =~ s/\'/''/g;
    my @ent;
    my %ent_to_p = ();
    my $tot = 0;
    if ($dbh)
    {
	my $sth = $dbh->prepare("SELECT * FROM dictionary WHERE entry = '".uri_escape_utf8($entry)."'");
	$sth->execute();
	while(my $tupla = $sth->fetchrow_hashref()) 
	{    	    
	    @ent = split(" ",uri_unescape($tupla->{'entities'}));
	    foreach my $ent_frek (@ent)
	    {
		my($enti,$frek)= &parse_ent_freq($ent_frek);
		$ent_to_p{$enti} = $frek;
		$tot += $frek;
	    }
	}
	$tot = 1 if $tot eq 0;
	my $kont = 1;
	foreach my $ent (sort{$ent_to_p{$b} <=> $ent_to_p{$a}} keys %ent_to_p)
	{
	    my $ent_p = $ent.":".($ent_to_p{$ent}/$tot);
	    push (@result,$ent_p);
	    last if ($kont eq $top_k) && ($top_k ne 0);
	    $kont++;
	}
    }
    else
    {
	die "database not working\n";		
    }
    return @result ;
}

sub parse_ent_freq
{
    my $str = shift;
    my ($ent, $freq);
    $freq = 0;
    my @aux = split(/:/, $str);
    if (@aux > 1 && $aux[-1] =~ /\d+/) 
    {
	$freq = pop @aux;
    }
    $ent = join(":", @aux);
    return ($ent, $freq);
}

sub match_most_likely_BGlink
{
    my $string = $_[0];
    my @result;
    my @entries = merge_match($string);
    foreach my $entry (@entries)
    {
	push @result, get_most_likely_BGlink(lc($entry));
    }
    return @result ;
}

sub match_all_BGlinks
{
    my $string = $_[0];
    my @result;
    my @entries = merge_match($string);
    foreach my $entry (@entries)
    {
	push @result,get_BGlinks(lc($entry));
    }
    return @result ;
}

sub merge_match
{
    my $orig_text = $_[0];
    my @match_garbia = match(garbitu($orig_text));
    my %match_garbia_h;
    my @match = match($orig_text);  
    my %match_h;
    my @emaitza;
    my %w_hasierak;
    my $offset = 0;
    foreach my $m (@match){
	$m =~ s/\_/ /g;
	my $starts = index($orig_text,$m,$offset);  
	$m =~ s/ /\_/g;
	$match_h{$starts}=$m;
	$w_hasierak{$starts}++;
	$offset =  $starts + length($m);
    }
    $offset = 0;
    foreach my $m_g (@match_garbia){
	$m_g =~ s/\_/ /g;
	my $starts = index($orig_text,$m_g,$offset);  
	$m_g =~ s/ /\_/g;
	$match_garbia_h{$starts}=$m_g;
	$w_hasierak{$starts}++;
	$offset =  $starts + length($m_g);
    }
    my $off=0;
    foreach my $w_s (sort {$a <=> $b} keys %w_hasierak)
    {
	next if $w_s < $off;
	if ($w_hasierak{$w_s} eq 2)
	{
	    if(length($match_h{$w_s})>=length($match_garbia_h{$w_s}) )
	    {
		$match_h{$w_s} =~ s/,$//g;
		push(@emaitza,$match_h{$w_s});
		$off = $w_s + length($match_h{$w_s});
	    }
	    else
	    {
		push(@emaitza,$match_garbia_h{$w_s});
		$off = $w_s + length($match_garbia_h{$w_s});
	    }
	}
	else
	{
	    if (defined $match_h{$w_s})
	    {
		$match_h{$w_s} =~ s/,$//g;
		push(@emaitza,$match_h{$w_s}); 
		$off = $w_s + length($match_h{$w_s});
	    }
	    if (defined $match_garbia_h{$w_s})
	    {
		push(@emaitza,$match_garbia_h{$w_s}); 
		$off = $w_s + length($match_garbia_h{$w_s});
	    }
	}
    }    
    return @emaitza;
}

sub match
{
    my %firstword_maximunlength = ();
    my @emaitza;
    my $orig_text = $_[0];
    my @tokens = split(" ", $orig_text);
    foreach my $token (@tokens)
    {
	next if (defined($stopwords{lc($token)}));
	$token =~ s/\'/''/g;
	my $sth = $dbh->prepare("SELECT * FROM firstword WHERE firstword = E'".uri_escape_utf8(lc($token))."'");
	$sth->execute();
	while(my $tupla = $sth->fetchrow_hashref()) 
	{
	    $firstword_maximunlength{uri_unescape($tupla->{'firstword'})}=$tupla->{'maximunlength'};
	}    
    }   
    my $i;
    for($i = 0; $i <= @tokens; $i++) 
    {
	next if !defined($tokens[$i]);
	my $uneko_lehen_hitza = $tokens[$i];
	my $luzeena;
	my $uneko_hitz_zerrenda = $uneko_lehen_hitza;
	next if !defined($firstword_maximunlength{lc($uneko_lehen_hitza)});
	
	for(my $ii = $i+1; $ii <= @tokens; $ii++)
	{
	    $uneko_hitz_zerrenda =~ s/\'/''/g;
	    my $sth = $dbh->prepare("SELECT * FROM dictionary WHERE entry = E'".uri_escape_utf8(lc($uneko_hitz_zerrenda))."'");
	    $sth->execute();
	    if(my $tupla = $sth->fetchrow_hashref())
	    {
		$luzeena = $uneko_hitz_zerrenda; 
	    }
	    last if (length($uneko_hitz_zerrenda) >= $firstword_maximunlength{lc($uneko_lehen_hitza)});
	    $uneko_hitz_zerrenda =  $uneko_hitz_zerrenda."_".$tokens[$ii] if defined $tokens[$ii];
	}
	if(defined($luzeena))
	{
	    #my ($better_matx,$merezi_du,$offset) = merezi_du($luzeena,"0_0");
	    if ($UPPER){
		push (@emaitza,"$luzeena") if $luzeena =~ /[A-Z]/;
	    }
	    else{
		push (@emaitza,"$luzeena");
	    }
	    foreach my $t (split("_",$luzeena))
	    {
		$i ++; 
	    }
	    $i--;
	}
	
    }
    return @emaitza; 
}

sub to_anchor
{
    my $str = $_[0];
    $str =~ s/ /\_/g;
    return lc($str);
}

sub garbitu
{
    my $zatia = $_[0];
    $zatia =~ s/(\w\w)\./$1 # /g;
    $zatia =~ s/,/ # /g;
    $zatia =~ s/:/ # /g;
    $zatia =~ s/!/ # /g;
    $zatia =~ s/\?/ # /g;
    $zatia =~ s/;/ # /g;
    $zatia =~ s/"/ /g;
    $zatia =~ s/\(/ # /g;
    $zatia =~ s/\)/ # /g;
    return $zatia;
}

sub init_stopwords
{    

    my $heredoc = << 'ENDHEREDOC' ;
x
y
your
yours
yourself
yourselves
you
yond
yonder
yon
ye
yet
z
zillion
j
u
umpteen
usually
username
uponed
upons
uponing
upon
ups
upping
upped
up
unto
until
unless
unlike
unliker
unlikest
under
underneath
use
used
usedest
r
rath
rather
rathest
rathe
re
relate
related
relatively
regarding
really
res
respecting
respectively
q
quite
que
qua
n
neither
neaths
neath
nethe
nethermost
necessary
necessariest
necessarier
never
nevertheless
nigh
nighest
nigher
nine
noone
nobody
nobodies
nowhere
nowheres
no
noes
nor
nos
no-one
none
not
notwithstanding
nothings
nothing
nathless
natheless
t
ten
tills
till
tilled
tilling
to
towards
toward
towardest
towarder
together
too
thy
thyself
thus
than
that
those
thou
though
thous
thouses
thoroughest
thorougher
thorough
thoroughly
thru
thruer
thruest
thro
through
throughout
throughest
througher
thine
this
thises
they
thee
the
then
thence
thenest
thener
them
themselves
these
therer
there
thereby
therest
thereafter
therein
thereupon
therefore
their
theirs
thing
things
three
two
o
oh
owt
owning
owned
own
owns
others
other
otherwise
otherwisest
otherwiser
of
often
oftener
oftenest
off
offs
offest
one
ought
oughts
our
ours
ourselves
ourself
out
outest
outed
outwith
outs
outside
over
overallest
overaller
overalls
overall
overs
or
orer
orest
on
oneself
onest
ons
onto
a
atween
at
athwart
atop
afore
afterward
afterwards
after
afterest
afterer
ain
an
any
anything
anybody
anyone
anyhow
anywhere
anent
anear
and
andor
another
around
ares
are
aest
aer
against
again
accordingly
abaft
abafter
abaftest
abovest
above
abover
abouter
aboutest
about
aid
amidst
amid
among
amongst
apartest
aparter
apart
appeared
appears
appear
appearing
appropriating
appropriate
appropriatest
appropriates
appropriater
appropriated
already
always
also
along
alongside
although
almost
all
allest
aller
allyou
alls
albeit
awfully
as
aside
asides
aslant
ases
astrider
astride
astridest
astraddlest
astraddler
astraddle
availablest
availabler
available
aughts
aught
vs
v
variousest
variouser
various
via
vis-a-vis
vis-a-viser
vis-a-visest
viz
very
veriest
verier
versus
k
g
go
gone
good
got
gotta
gotten
get
gets
getting
b
by
byandby
by-and-by
bist
both
but
buts
be
beyond
because
became
becomes
become
becoming
becomings
becominger
becomingest
behind
behinds
before
beforehand
beforehandest
beforehander
bettered
betters
better
bettering
betwixt
between
beneath
been
below
besides
beside
m
my
myself
mucher
muchest
much
must
musts
musths
musth
main
make
mayest
many
mauger
maugre
me
meanwhiles
meanwhile
mostly
most
moreover
more
might
mights
midst
midsts
h
huh
humph
he
hers
herself
her
hereby
herein
hereafters
hereafter
hereupon
hence
hadst
had
having
haves
have
has
hast
hardly
hae
hath
him
himself
hither
hitherest
hitherer
his
how-do-you-do
however
how
howbeit
howdoyoudo
hoos
hoo
w
woulded
woulding
would
woulds
was
wast
we
wert
were
with
withal
without
within
why
what
whatever
whateverer
whateverest
whatsoeverer
whatsoeverest
whatsoever
whence
whencesoever
whenever
whensoever
when
whenas
whether
wheen
whereto
whereupon
wherever
whereon
whereof
where
whereby
wherewithal
wherewith
whereinto
wherein
whereafter
whereas
wheresoever
wherefrom
which
whichever
whichsoever
whilst
while
whiles
whithersoever
whither
whoever
whosoever
whoso
whose
whomever
s
syne
syn
shalling
shall
shalled
shalls
shoulding
should
shoulded
shoulds
she
sayyid
sayid
said
saider
saidest
same
samest
sames
samer
saved
sans
sanses
sanserifs
sanserif
so
soer
soest
sobeit
someone
somebody
somehow
some
somewhere
somewhat
something
sometimest
sometimes
sometimer
sometime
several
severaler
severalest
serious
seriousest
seriouser
senza
send
sent
seem
seems
seemed
seemingest
seeminger
seemings
seven
summat
sups
sup
supping
supped
such
since
sine
sines
sith
six
stop
stopped
p
plaintiff
plenty
plenties
please
pleased
pleases
per
perhaps
particulars
particularly
particular
particularest
particularer
pro
providing
provides
provided
provide
probably
l
layabout
layabouts
latter
latterest
latterer
latterly
latters
lots
lotting
lotted
lot
lest
less
ie
ifs
if
i
info
information
itself
its
it
is
idem
idemer
idemest
immediate
immediately
immediatest
immediater
in
inwards
inwardest
inwarder
inward
inasmuch
into
instead
insofar
indicates
indicated
indicate
indicating
indeed
inc
f
fact
facts
fs
figupon
figupons
figuponing
figuponed
few
fewer
fewest
frae
from
failing
failings
five
furthers
furtherer
furthered
furtherest
further
furthering
furthermore
fourscore
followthrough
for
forwhy
fornenst
formerly
former
formerer
formerest
formers
forbye
forby
fore
forever
forer
fores
four
d
ddays
dday
do
doing
doings
doe
does
doth
downwarder
downwardest
downward
downwards
downs
done
doner
dones
donest
dos
dost
did
differentest
differenter
different
describing
describe
describes
described
despiting
despites
despited
despite
during
c
cum
circa
chez
cer
certain
certainest
certainer
cest
canst
cannot
cant
cants
canting
cantest
canted
co
could
couldst
comeon
comeons
come-ons
come-on
concerning
concerninger
concerningest
consequently
considering
e
eg
eight
either
even
evens
evenser
evensest
evened
evenest
ever
everyone
everything
everybody
everywhere
every
ere
each
et
etc
elsewhere
else
ex
excepted
excepts
except
excepting
exes
enough
nlnl
.
,
;
:
!
?
..
...
``
''
"
)
(
[
]
{
}
1
2
3
4
5
6
7
8
9
&amp;
&lt;
&gt;
'
ln
$
'_'
's
&
ENDHEREDOC

foreach (split(/\n/,$heredoc)) {
	chomp;
	$stopwords{"$_"} = 1;
    }
}


1;
